<link rel="stylesheet" href="/training/css/training.css">

<div id="training" class="section-profile">
    <div class="row">
        <div class="topleft duk-icon"><img onclick="removeSection('training')" src="/gui/img/x.png"></div>
        <div class="bottomright duk-icon"><img onclick="toggleSidebar('training-sidebar')" src="/gui/img/expand.png"></div>
        <div id="training-sidebar" class="column section-border" style="flex:25%;">
            <img src="/training/img/certification.png">
            <h4>Training</h4>
            <p class="section-description">
                To the right you will find virtual flags, similar to a capture-the-flag event. As you work through
                each one, more flags will be displayed. Complete all the flags and you will receive a proof of
                completion. The flags will automatically update (within 15 seconds)
                as you work through the challenges. Each time you complete a section, a badge (below) will be activated.
            </p>
            <br>
            <select id="certification-name" style="margin-top:-15px" onchange="loadCertification();">
                <option value="" disabled selected>Select a certificate</option>
                {% for cert in certificates %}
                    <option value="{{ cert.name }}">{{ cert.name }}</option>
                {% endfor %}}
            </select>
            <ul id="badges" class="profile-tests"></ul>
        </div>
        <div class="column" style="flex:75%;">
            <div id="training-disclaimers">
                <p class="training-disclaimer-important">
                    Training plugin should only be used with tagged releases
                </p>
                <p>
                    If you earn a code, send it to caldera@mitre.org. We will validate it and send back an
                    authenticated code as proof of completion.
                </p>
            </div>
            <ul id="flags" class="profile-tests"></ul>
        </div>
    </div>
</div>

<li id="flag-template" class="flag-box flip-card" style="display: none">
    <div class="flip-card-inner">
        <div class="flip-card-front">
            <h3 id="flag-number"></h3>
            <h4 id="flag-name"></h4>
            <p id="flag-challenge" class="flag-challenge" style="white-space: pre-line"></p>
            <center>
                <h1 id="flag-status"></h1>
            </center>
            <br>
            <b><p id="flag-completed-ts" class="flag-bottom"></p></b>
        </div>
        <div class="flip-card-back">
            <p id="flag-info" style="white-space: pre-line"></p>
        </div>
    </div>
</li>

<li id="badge-template" style="margin:10px;display:none">
    <div class="badge-icon">
        <b><p id="badge-name"></p></b>
        <img id="badge-icon"/>
    </div>
</li>

<script>
    let refresher = setInterval(refresh, 15000);
    $('.section-profile').bind('destroyed', function() {
        clearInterval(refresher);
    });
    $(document).ready(function () {
        refresh();
    });
    
    function loadCertification(){
        function loadCert(data){
            data[0].badges.forEach(function(badge) {
                let template = $("#badge-template").clone();
                template.attr("id", "badge-" + badge.name);
                template.find('#badge-name').text(badge.name);
                template.find('#badge-icon').attr('src', '/training/img/badges/'+badge.name+'.png');
                template.show();
                $('#badges').append(template);
            });
            refresh();
        }
        let selectedCert = $('#certification-name option:selected').attr('value');
        stream('Hover over each flag to get adversary emulation tips & tricks!');
        $('#badges').empty();
        restRequest('POST', {"index":"certifications","name":selectedCert}, loadCert)
    }

    function refresh(){
        function updateFlags(data){
            let completedBadges = 0;
            let code = [];
            let flags = $('#flags');
            flags.empty();
            try {
                data.badges.forEach(function(badge) {
                    let badgeComplete = 0;
                    badge.flags.forEach(function(flag) {
                        let template = $("#flag-template").clone();
                        template.find('#flag-number').html('&#127937 ' + flag.number);
                        template.find('#flag-name').text(flag.name);
                        template.find("#flag-challenge").text(flag.challenge);
                        template.find("#flag-info").text(flag.extra_info);
                        template.find("#flag-completed-ts").text(flag.completed_ts);
                        if(flag.completed) {
                            template.find('#flag-status').html('&#x2705;');
                            badgeComplete += 1;
                            code.push(flag.code);
                        } else {
                            template.find('#flag-status').html('&#10060;');
                            template.show();
                            flags.append(template);
                            throw Exception; //show only the next incomplete flag
                        }
                        template.show();
                        flags.append(template);
                    });
                    if(badgeComplete === badge.flags.length) {
                        let b = $('#badge-'+badge.name);
                        b.find('.badge-icon').css('opacity', 1.0);
                        b.find('.badge-icon').css('background-color', 'darkgreen');
                        completedBadges += 1
                    }
                });
                displayCert(code, completedBadges, data.badges.length);

            } catch(e) { }
        }
        let selectedCert = $('#certification-name option:selected').attr('value');
        if(!selectedCert){
            return;
        }
        $('#training-disclaimers').hide();
        restRequest('POST', {"name":selectedCert}, updateFlags, '/plugin/training/flags');
    }

    function displayCert(code, completedBadges, totalBadges) {
        if(completedBadges === totalBadges) {
            code = code.sort(function(a, b) {
                return a.toString().length - b.toString().length;
            });
            code = code.join(' ');
            document.getElementById("alert-modal").style.display="block";
            $('#alert-text').text(btoa(code)).css('word-wrap', 'break-word');
            clearInterval(refresher);
        }
    }
</script>